C&    CONTROL /PROFILE/ SUMMARY(NO),OUTPUT(80),LEVEL(1),LIST(NO)        00001000
C&    CONTROL /PROFILE/ UPDATE(YES),DOCU(YES)                           00002000
C&    CONTROL /MESSAGE/ OFF(132,5108)                                   00003000
C*****APCGMA                                                            00004000
      DOUBLE PRECISION FUNCTION APCGMA( Y, P, IFAULT )                  00005000
      INTEGER          IFAULT, ITER  , MAXITR                           00087000
      DOUBLE PRECISION AN    , APLGMA, A     , B     , DIF   ,          00089000
     *                 EPS   , F     , GIN   , MINEXP, OFLO  , PN    ,  00090000
     *                 P     , RN    , TERM  , Y                        00091000
      DIMENSION PN(6)                                                   00092000
      DATA       EPS   / 1.0D-12 /                                      00093000
      DATA       MAXITR/ 200     /                                      00094000
      DATA       OFLO  / 1.0D+38 /                                      00095000
      DATA       MINEXP/ -87.0D0 /                                      00096000
      IFAULT = 1                                                        00100000
      APCGMA = 1.0D0                                                    00101000
      IF( ( Y .LE. 0.0D0 ) .OR. ( P .LE. 0.0D0 ) ) GO TO 9000           00102000
      IFAULT = 0                                                        00106000
      F      = P * DLOG( Y ) - APLGMA( P + 1.0D0 ) - Y                  00107000
      IF( F .LT. MINEXP ) GO TO 9000                                    00108000
      F      = DEXP( F )                                                00110000
      IF( F .EQ. 0.0D0 ) GO TO 9000                                     00111000
      IF( ( Y .GT. 1.0D0 ) .AND. ( Y .GE. P ) ) GO TO 30                00113000
      ITER   = 0                                                        00117000
      TERM   = 1.0D0                                                    00119000
      APCGMA = 1.0D0                                                    00120000
      A      = P                                                        00121000
   1  A      = A + 1.0D0                                                00123000
      TERM   = TERM * Y / A                                             00124000
      APCGMA = APCGMA + TERM                                            00125000
      ITER   = ITER + 1                                                 00127000
      IF( ITER .GT. MAXITR ) GO TO 2                                    00128000
         IF( TERM / APCGMA .GT. EPS ) GO TO 1                           00130000
   2  APCGMA = APCGMA * F                                               00132000
      GO TO 9000                                                        00133000
  30  A       = 1.0D0 - P                                               00137000
      B       = A + Y + 1.0D0                                           00138000
      TERM    = 0.0D0                                                   00139000
      PN( 1 ) = 1.0D0                                                   00140000
      PN( 2 ) = Y                                                       00141000
      PN( 3 ) = Y + 1.0D0                                               00142000
      PN( 4 ) = Y * B                                                   00143000
      GIN     = PN( 3 ) / PN( 4 )                                       00144000
      ITER    = 0                                                       00145000
  32  A      = A + 1.0D0                                                00147000
      B      = B + 2.0D0                                                00148000
      TERM   = TERM + 1.0D0                                             00149000
      AN     = A * TERM                                                 00150000
      PN( 5 ) = B * PN( 3 ) - AN * PN( 1 )                              00152000
      PN( 6 ) = B * PN( 4 ) - AN * PN( 2 )                              00153000
      IF( PN( 6 ) .EQ. 0.0D0 ) GO TO 35                                 00155000
         RN     = PN( 5 ) / PN( 6 )                                     00157000
         DIF    = DABS( GIN - RN )                                      00158000
         IF( DIF .GT. EPS ) GO TO 34                                    00160000
            IF( DIF .LE. ( EPS * RN ) ) GO TO 42                        00162000
  34     GIN    = RN                                                    00164000
         ITER   = ITER + 1                                              00166000
         IF( ITER .GT. MAXITR ) GO TO 42                                00167000
  35  PN( 1 ) = PN( 3 )                                                 00169000
      PN( 2 ) = PN( 4 )                                                 00170000
      PN( 3 ) = PN( 5 )                                                 00171000
      PN( 4 ) = PN( 6 )                                                 00172000
      IF( DABS( PN( 5 ) ) .LT. OFLO ) GO TO 32                          00174000
         PN( 1 ) = PN( 1 ) / OFLO                                       00176000
         PN( 2 ) = PN( 2 ) / OFLO                                       00177000
         PN( 3 ) = PN( 3 ) / OFLO                                       00178000
         PN( 4 ) = PN( 4 ) / OFLO                                       00179000
         GO TO 32                                                       00180000
  42  GIN    = 1.0D0 - ( F * GIN * P )                                  00182000
      APCGMA = GIN                                                      00184000
 9000 RETURN                                                            00186000
      END                                                               00187000
C*****APDERF                                                            00452000
      DOUBLE PRECISION FUNCTION APDERF( Z )                             00453000
      DOUBLE PRECISION A     , B     , U     , X     , Z                00514000
      DIMENSION A(14),B(12)                                             00515000
      DATA    A                 /1.1283791670955D0,.34197505591854D0,   00516000
     C.86290601455206D-1,.12382023274723D-1,.11986242418302D-2,         00517000
     C.76537302607825D-4,.25365482058342D-5,-.99999707603738D0,         00518000
     C-1.4731794832805D0,-1.0573449601594D0,-.44078839213875D0,         00519000
     C-.10684197950781D0,-.12636031836273D-1,-.1149393366616D-8/        00520000
      DATA  B                   /-.36359916427762D0,.52205830591727D-1, 00521000
     C-.30613035688519D-2,-.46856639020338D-4,.15601995561434D-4,       00522000
     C-.62143556409287D-6,2.6015349994799D0,2.9929556755308D0,          00523000
     C1.9684584582884D0,.79250795276064D0,.18937020051337D0,            00524000
     C.22396882835053D-1/                                               00525000
      APDERF=0.0D0                                                      00529000
      IF (Z .EQ. 0.0D0) GO TO 9800                                      00530000
      X=DABS(Z)                                                         00534000
      APDERF=DSIGN(1.0D0,Z)                                             00535000
      IF (X .GE. 5.5D0) GO TO 9800                                      00536000
      U = X*X                                                           00537000
      IF (X .GT. 1.5D0) GO TO 1                                         00538000
      APDERF = (X*DEXP(-U)*(A(1)+U*(A(2)+U*(A(3)+U*(A(4)+U*(A(5)        00542000
     1+U*(A(6)+U*A(7)))))))/(1.0D0+U*(B(1)+U*(B(2)+U*(B(3)              00543000
     2+U*(B(4)+U*(B(5)+U*B(6)))))))) * DSIGN(1.0D0,Z)                   00544000
      GO TO 9800                                                        00545000
    1 APDERF = (DEXP(-U)*(A(8)+X*(A(9)+X*(A(10)+X*(A(11)+X*(A(12)       00549000
     1+X*(A(13)+X*A(14)))))))/(1.0D0+X*(B(7)+X*(B(8)+X*(B(9)            00550000
     2+X*(B(10)+X*(B(11)+X*B(12)))))))+1.0D0)*DSIGN(1.0D0,Z)            00551000
 9800 CONTINUE                                                          00552000
      RETURN                                                            00553000
      END                                                               00554000
C*****APFEXT                                                            00555000
      SUBROUTINE APFEXT( N1, N2, N3, N4, P1TAIL, P2TAIL )               00556000
      INTEGER          HOLD  , I     , N1    , N2    , N3    , N4    ,  00639000
     *                 W1    , W2    , W3    , W4                       00640000
      DOUBLE PRECISION APLGMA, APLGMI, P1TAIL, P1    , P2TAIL, PEXACT,  00642000
     *                 PLOG  , RATIOC, RATIOM, RLGMIN, Z1    , Z2    ,  00643000
     *                 Z3    , Z4                                       00644000
      DATA       RLGMIN/ -675.81850104594D0 /                           00645000
      APLGMI( I ) = APLGMA( DBLE( FLOAT( I ) ) )                        00647000
      IF( N2 .LT. N1 ) GO TO 320                                        00651000
      IF( N3 .LT. N1 ) GO TO 330                                        00652000
      IF( N4 .LT. N1 ) GO TO 340                                        00653000
      W1     = N1                                                       00655000
      W2     = N2                                                       00656000
      W3     = N3                                                       00657000
      W4     = N4                                                       00658000
      GO TO 350                                                         00659000
  320 IF( N3 .LT. N2 ) GO TO 330                                        00661000
      IF( N4 .LT. N2 ) GO TO 340                                        00662000
      W1     = N2                                                       00663000
      W2     = N1                                                       00664000
      W3     = N4                                                       00665000
      W4     = N3                                                       00666000
      GO TO 350                                                         00667000
  330 IF( N4 .LT. N3 ) GO TO 340                                        00669000
      W1     = N3                                                       00670000
      W2     = N1                                                       00671000
      W3     = N4                                                       00672000
      W4     = N2                                                       00673000
      GO TO 350                                                         00674000
  340 W1     = N4                                                       00676000
      W2     = N3                                                       00677000
      W3     = N2                                                       00678000
      W4     = N1                                                       00679000
  350 CONTINUE                                                          00684000
      P1TAIL = 1.0D0                                                    00685000
      P2TAIL = 0.0D0                                                    00686000
      RATIOC = W1 + W2                                                  00687000
      RATIOM = RATIOC + W3 + W4                                         00688000
      IF( RATIOM .EQ. 0.0D0 )  GO TO 9000                               00690000
      RATIOM = ( W1 + W3 ) / RATIOM                                     00692000
      IF( RATIOC .NE. 0.0D0 )  RATIOC = W1 / RATIOC                     00693000
      IF( RATIOM .GE. RATIOC ) GO TO 365                                00695000
         IF( W3 .LT. W2 ) GO TO 360                                     00697000
            HOLD   = W2                                                 00699000
            W2     = W1                                                 00700000
            W1     = HOLD                                               00701000
            HOLD   = W4                                                 00702000
            W4     = W3                                                 00703000
            W3     = HOLD                                               00704000
            GO TO 365                                                   00705000
  360    CONTINUE                                                       00707000
            HOLD   = W3                                                 00708000
            W3     = W1                                                 00709000
            W1     = HOLD                                               00710000
            HOLD   = W4                                                 00711000
            W4     = W2                                                 00712000
            W2     = HOLD                                               00713000
  365 CONTINUE                                                          00714000
      Z1      = 0.0D0                                                   00718000
      Z2      = W2 + W1                                                 00719000
      Z3      = W3 + W1                                                 00720000
      Z4      = W4 - W1                                                 00721000
      PLOG   = APLGMI( W3 + W4 + 1 ) -                                  00723000
     1         APLGMI( W1 + W2 + W3 + W4 + 1 ) +                        00724000
     2         APLGMI( W2 + W4 + 1 ) -                                  00725000
     3         APLGMI( W4 - W1 + 1 )                                    00726000
      P1TAIL = 0.0D0                                                    00728000
      IF( PLOG .GT. RLGMIN ) P1TAIL = DEXP( PLOG )                      00729000
      P1     = P1TAIL                                                   00733000
      IF( W1 .LT. 1) GO TO 390                                          00735000
         DO 370 I = 1 , W1                                              00737000
            Z1     = Z1 + 1.0D0                                         00738000
            Z4     = Z4 + 1.0D0                                         00739000
            P1     = P1 * Z2 * Z3 / Z1 / Z4                             00740000
            Z2     = Z2 - 1.0D0                                         00741000
            Z3     = Z3 - 1.0D0                                         00742000
            P1TAIL = P1TAIL + P1                                        00743000
  370    CONTINUE                                                       00744000
  390 CONTINUE                                                          00746000
      PEXACT = P1                                                       00748000
      IF( W2 .LE. W3 )  GO TO 400                                       00752000
         HOLD   = W2                                                    00754000
         W2     = W3                                                    00755000
         W3     = HOLD                                                  00756000
  400 CONTINUE                                                          00758000
      IF( W2 .LT. 1 )  GO TO 420                                        00760000
         Z1      = W1 + W2                                              00762000
         Z2      = 0.0D0                                                00763000
         Z3      = W3 - W2                                              00764000
         Z4      = W4 + W2                                              00765000
         PLOG   = APLGMI( W1 + W3 + 1 ) -                               00767000
     1            APLGMI( W1 + W2 + W3 + W4 + 1 ) +                     00768000
     2            APLGMI( W3 + W4 + 1 ) -                               00769000
     3            APLGMI( W3 - W2 + 1 )                                 00770000
         P1     = 0.0D0                                                 00772000
         IF( PLOG .GT. RLGMIN ) P1 = DEXP( PLOG )                       00773000
         IF( P1 .GT. PEXACT )  GO TO 420                                00775000
            P2TAIL = P1                                                 00777000
            I      = 1                                                  00781000
  410       CONTINUE                                                    00783000
            IF( I .GE. W2 )  GO TO 420                                  00784000
              Z2     = Z2 + 1.0D0                                       00786000
              Z3     = Z3 + 1.0D0                                       00787000
              P1     = P1 * Z1 * Z4 / Z2 / Z3                           00788000
              Z1     = Z1 - 1.0D0                                       00789000
              Z4     = Z4 - 1.0D0                                       00790000
              IF( P1 .GT. PEXACT )  GO TO 420                           00792000
                P2TAIL = P2TAIL + P1                                    00794000
                I      = I + 1                                          00795000
                GO TO 410                                               00796000
  420    CONTINUE                                                       00798000
         P2TAIL = P1TAIL + P2TAIL                                       00800000
 9000 RETURN                                                            00802000
      END                                                               00803000
C*****APINVB                                                            00804000
      DOUBLE PRECISION FUNCTION APINVB( P, ALPHA, BETA )                00805000
      INTEGER          ITER  , MAXITR                                   00897000
      DOUBLE PRECISION A1    , AA    , ADJ   , ALPHA , APINVN,          00899000
     *                 APLGMA, APSIGB, B1    , BB    , BETA  , CMPLBT,  00900000
     *                 EPSZ  , FIM1  , FI    , G     , H     , PP    ,  00901000
     *                 PSING , P     , R     , SQ    , S     , T     ,  00902000
     *                 W     , XIM1  , XIP1  , XI                       00903000
      DATA       EPSZ  / 1.0D-26 /                                      00904000
      DATA       MAXITR/ 50 /                                           00906000
      IF( ALPHA .LE. 0.0D0 ) GO TO 9005                                 00910000
      IF( BETA  .LE. 0.0D0 ) GO TO 9005                                 00911000
      IF( ( P .GT. 1.0D0 ) .OR. ( P .LT. 0.0D0 ) ) GO TO 9005           00913000
      IF( P .GT. 0.5D0 ) GO TO 10                                       00918000
         AA     = ALPHA                                                 00920000
         BB     = BETA                                                  00921000
         PP     = P                                                     00922000
         GO TO 20                                                       00923000
  10     AA     = BETA                                                  00925000
         BB     = ALPHA                                                 00926000
         PP     = 1.0D0 - P                                             00927000
  20  CMPLBT = APLGMA( AA ) + APLGMA( BB ) -                            00933000
     1         APLGMA( AA + BB )                                        00934000
      PSING  = 1.0D0 - PP                                               00936000
      FI     = APINVN( PSING )                                          00937000
      IF( ( AA .GT. 1.0D0 ) .AND. ( BB .GT. 1.0D0 ) ) GO TO 40          00939000
         R      = BB + BB                                               00941000
         T      = 1.0D0 / ( 9.0D0 * BB )                                00942000
         T      = R * ( 1.0D0 - T + FI * DSQRT( T ) ) ** 3              00943000
         IF( T .GT. 0.0D0 ) GO TO 30                                    00945000
            XI     = 1.0D0 - DEXP( ( DLOG( ( 1.0D0 - PP ) * BB )        00947000
     1                            + CMPLBT ) / BB )                     00948000
            GO TO 50                                                    00949000
  30     T      = ( 4.0D0 * AA + R - 2.0D0 ) / T                        00951000
         IF( T .LE. 1.0D0 ) XI = DEXP( (DLOG( PP * AA ) + CMPLBT) / PP) 00953000
         IF( T .GT. 1.0D0 ) XI = 1.0D0 - 2.0D0 / ( T + 1.0D0 )          00954000
         GO TO 50                                                       00955000
  40     R      = ( FI * FI - 3.0D0 ) / 6.0D0                           00957000
         S      = 1.0D0 / ( AA + AA - 1.0D0 )                           00958000
         T      = 1.0D0 / ( BB + BB - 1.0D0 )                           00959000
         H      = 2.0D0 / ( S + T )                                     00960000
         W      = FI * DSQRT( H + R ) / H - ( T - S ) *                 00961000
     1            ( R + 5.0D0 / 6.0D0 - 2.0D0 / ( 3.0D0 * H ) )         00962000
         XI     = AA / ( AA + BB * DEXP( W + W ) )                      00963000
  50  A1     = 1.0D0 - AA                                               00967000
      B1     = 1.0D0 - BB                                               00968000
      FIM1   = 0.0D0                                                    00969000
      SQ     = 1.0D0                                                    00970000
      XIM1   = 1.0D0                                                    00971000
      IF(XI.LT.0.0001D0) XI=0.0001D0                                    00975000
      IF(XI.GT.0.9999D0) XI=0.9999D0                                    00976000
      DO 100 ITER = 1 , MAXITR                                          00978000
         FI     = APSIGB( XI, AA, BB )                                  00980000
         IF( FI .LT. 0.0D0 ) GO TO 9005                                 00981000
         FI     = ( FI - PP ) * DEXP( CMPLBT + A1 * DLOG( XI ) +        00983000
     1                               B1 * DLOG( 1.0D0 - XI ) )          00984000
         IF( ( FI * FIM1 ) .LE. 0.0D0 ) XIM1 = SQ                       00986000
         G      = 1.0D0                                                 00988000
  60     ADJ    = G * FI                                                00990000
         SQ     = ADJ * ADJ                                             00991000
         IF( SQ .LT. XIM1 ) GO TO 70                                    00993000
            G      = G / 3.0D0                                          00995000
            GO TO 60                                                    00996000
  70        XIP1     = XI - ADJ                                         00998000
            IF( ( XIP1 .GE. 0.0D0 ) .AND.                               00999000
     1          ( XIP1 .LE. 1.0D0 ) ) GO TO 80                          01000000
               G      = G / 3.0D0                                       01002000
               GO TO 60                                                 01003000
  80     IF( XIM1    .LE. EPSZ ) GO TO 9000                             01005000
         IF( FI * FI .LE. EPSZ ) GO TO 9000                             01006000
         IF( ( XIP1 .EQ. 0.0D0 ) .OR.                                   01008000
     1       ( XIP1 .EQ. 1.0D0 ) ) GO TO 70                             01009000
         IF( XIP1 .EQ. XI ) GO TO 9000                                  01011000
            XI     = XIP1                                               01013000
            FIM1   = FI                                                 01014000
  100 CONTINUE                                                          01016000
 9000 APINVB = XI                                                       01018000
      IF( P .GT. 0.5D0 ) APINVB = 1.0D0 - APINVB                        01019000
      RETURN                                                            01021000
 9005 XI     = -1.0D0                                                   01023000
      GO TO 9000                                                        01024000
      END                                                               01026000
C*****APINVC                                                            01027000
      DOUBLE PRECISION FUNCTION APINVC(P,V,IFAULT)                      01028000
      INTEGER          IF1   , IFAULT                                   01090000
      DOUBLE PRECISION AA    , APCGMA, APINVN, APLGMA, A     ,          01092000
     *                 B     , CH    , C     , E     , G     , P1    ,  01093000
     *                 P2    , P     , Q     , S1    , S2    , S3    ,  01094000
     *                 S4    , S5    , S6    , T     , V     , XX    ,  01095000
     *                 X                                                01096000
      DATA E, AA/0.5D-10, 0.6931471805D0/                               01097000
      APINVC=-1.0                                                       01101000
      IFAULT=1                                                          01102000
      IF(P.LT. E .OR. P.GT. (1-E)) GO TO 9800                           01103000
      IFAULT=2                                                          01104000
      IF(V.LE.0.D0) GO TO 9800                                          01105000
      G=APLGMA(0.5D0*V)                                                 01106000
      IFAULT=0                                                          01107000
      XX=0.5*V                                                          01108000
      C=XX-1.0                                                          01109000
      IF(V.GE.(-1.24*DLOG(P))) GO TO 1                                  01113000
      CH=(P*XX*DEXP(G+XX*AA))**(1.D0/XX)                                01114000
      IF(CH-E)6, 4, 4                                                   01115000
    1 IF(V .GT. 0.32D0) GO TO 3                                         01119000
      CH=0.4                                                            01120000
      A=DLOG(1.D0-P)                                                    01121000
    2 Q=CH                                                              01122000
      P1=1.0+CH*(4.67+CH)                                               01123000
      P2=CH*(6.73+CH*(6.66+CH))                                         01124000
      T=-0.5+(4.67+2.0*CH)/P1 - (6.73+CH*(13.32+3.0*CH))/P2             01126000
      CH=CH-(1.0-DEXP(A+G+0.5*CH+C*AA)*P2/P1)/T                         01127000
      IF(DABS(Q/CH-1.D0)-0.01D0) 4, 4, 2                                01128000
    3 CONTINUE                                                          01132000
      X=APINVN(P)                                                       01133000
      P1     = 2.0D0 / ( 9.0D0 * V )                                    01137000
      CH=V*(X*DSQRT(P1)+1.0-P1)**3                                      01138000
      IF(CH .GT. 2.2*V+6.0)                                             01142000
     *   CH=-2.0*(DLOG(1.0-P)-C*DLOG(0.5*CH)+G)                         01143000
    4 Q=CH                                                              01148000
      P1=0.5*CH                                                         01149000
      P2=P-APCGMA(P1,XX,IF1)                                            01150000
      IF(IF1.EQ.0) GOTO 5                                               01151000
      IFAULT=3                                                          01152000
      GO TO 9800                                                        01153000
    5 T=P2*DEXP(XX*AA+G+P1-C*DLOG(CH))                                  01154000
      B=T/CH                                                            01155000
      A=0.5*T-B*C                                                       01156000
      S1=(210.0+A*(140.0+A*(105.0+A*(84.0+A*(70.0+60.0*A)))))/420.0     01157000
      S2=(420.0+A*(735.0+A*(966.0+A*(1141.0+1278.0*A))))/2520.0         01158000
      S3=(210.0+A*(462.0+A*(707.0+932.0*A)))/2520.0                     01159000
      S4=(252.0+A*(672.0+1182.0*A)+C*(294.0+A*(889.0+1740.0*A)))/5040.0 01160000
      S5=(84.0+264.0*A+C*(175.0+606.0*A))/2520.0                        01161000
      S6=(120.0+C*(346.0+127.0*C))/5040.0                               01162000
      CH=CH+T*(1.0+0.5*T*S1-B*C*(S1-B*(S2-B*(S3-B*(S4-B*(S5-B*S6))))))  01163000
      IF(DABS(Q/CH-1.0).GT.E) GOTO 4                                    01164000
    6 APINVC=CH                                                         01166000
 9800 CONTINUE                                                          01167000
      RETURN                                                            01168000
      END                                                               01169000
C*****APINVF                                                            01170000
      DOUBLE PRECISION FUNCTION APINVF( ALPHA, DFN, DFE )               01171000
      DOUBLE PRECISION ALPHA , APINVB, DFE   , DFN                      01253000
      APINVF  = -1.0D0                                                  01254000
      IF( ( DFN .LE. 0.0D0 ) .OR. ( DFE .LE. 0.0D0 ) ) GO TO 9000       01256000
      IF( ( ALPHA .LT. 0.0D0 ) .OR. ( ALPHA .GT. 1.0D0 ) ) GO TO 9000   01258000
         APINVF = APINVB( ALPHA, DFN/2.0D0, DFE/2.0D0 )                 01260000
         IF( ( APINVF .GE. 0.0D0 ) .AND. ( APINVF .LT. 1.0D0 ) )        01262000
     1         APINVF  = APINVF * DFE / ( DFN * ( 1.0D0 - APINVF ) )    01263000
 9000 RETURN                                                            01265000
      END                                                               01266000
C*****APINVM                                                            01267000
      DOUBLE PRECISION FUNCTION APINVM( P )                             01268000
      DOUBLE PRECISION APINVN, APSIGN, P1    , PHI   , PI    ,          01312000
     *                 P     , X1    , X2    , X3    , XP    , Z        01313000
      DATA       PI/ 3.141592653589793D0 /                              01314000
      XP = APINVN( P )                                                  01316000
      P1 = APSIGN( XP )                                                 01318000
      PHI    = DSQRT( 1.0D0/( 2.0D0 * PI ))*DEXP( -( XP*XP )/2.D0)      01320000
      Z      = ( P - P1 ) / PHI                                         01322000
      X3     = ( 2.0D0 * ( XP * XP ) + 1.0D0 ) * Z / 3.0D0              01324000
      X2     = ( X3 + XP ) * Z / 2.0D0                                  01325000
      X1     = ( ( X2 + 1.0D0 ) * Z )                                   01326000
      APINVM = XP + X1                                                  01328000
      RETURN                                                            01330000
      END                                                               01331000
C*****APINVN                                                            01332000
      DOUBLE PRECISION FUNCTION APINVN( P )                             01333000
      DOUBLE PRECISION LIM   , PN    , PR    , P     , QN    ,          01401000
     *                 Y                                                01402000
      DIMENSION PN(5), QN(5)                                            01403000
      DATA       LIM/ 1.0D-20 /                                         01405000
      DATA       PN( 1 )/ -0.322232431088D0 /                           01407000
      DATA       PN( 2 )/ -1.0D0            /                           01408000
      DATA       PN( 3 )/ -0.342242088547D0 /                           01409000
      DATA       PN( 4 )/ -0.0204231210245D0 /                          01410000
      DATA       PN( 5 )/ -0.453642210148D-4 /                          01411000
      DATA       QN( 1 )/ 0.0993484626060D0 /                           01413000
      DATA       QN( 2 )/ 0.588581570495D0  /                           01414000
      DATA       QN( 3 )/ 0.531103462366D0  /                           01415000
      DATA       QN( 4 )/ 0.103537752850D0  /                           01416000
      DATA       QN( 5 )/ 0.38560700634D-2  /                           01417000
      APINVN  = 0.0D0                                                   01419000
      PR     = P                                                        01421000
      IF( PR .GT. 0.5D0 ) PR = 1.0D0 - PR                               01422000
      IF( PR .LT. LIM ) GO TO 9000                                      01424000
      IF( PR .EQ. 0.5D0 ) GO TO 9000                                    01426000
      Y      = DSQRT ( DLOG( 1.0D0 / PR / PR ) )                        01428000
      APINVN = Y + ((((Y * PN( 5 ) + PN( 4 )) * Y + PN( 3 ) ) * Y       01430000
     1                             + PN( 2 )) * Y + PN( 1 ) ) /         01431000
     2             ((((Y * QN( 5 ) + QN( 4 )) * Y + QN( 3 ) ) * Y       01432000
     3                             + QN( 2 )) * Y + QN( 1 ) )           01433000
      IF( P .LT. 0.5D0 ) APINVN = -APINVN                               01435000
 9000 RETURN                                                            01437000
      END                                                               01438000
C*****APINVT                                                            01439000
      DOUBLE PRECISION FUNCTION APINVT( ALPHA , DFE )                   01440000
      DOUBLE PRECISION ALPHA , APINVB, DFE                              01516000
      APINVT  = -1.0D0                                                  01517000
      IF( DFE .LE. 0.0D0 ) GO TO 9000                                   01519000
      IF( ( ALPHA .LT. 0.0D0 ) .OR. ( ALPHA .GT. 1.0D0 ) ) GO TO 9000   01521000
         APINVT = APINVB( ALPHA, 0.5D0, DFE/2.0D0 )                     01523000
         IF( ( APINVT .GE. 0.0D0 ) .AND. ( APINVT .LT. 1.0D0 ) )        01525000
     1         APINVT = DSQRT( APINVT * DFE / ( 1.0D0 - APINVT ) )      01526000
 9000 RETURN                                                            01528000
      END                                                               01529000
C*****APSIGB                                                            01530000
      DOUBLE PRECISION FUNCTION APSIGB( XX, ALPHA, BETA )               01531000
      INTEGER          MAXTRY, NTRIES                                   01621000
      DOUBLE PRECISION AEV   , AHI   , ALO   , ALPHA , AOD   , APB   ,  01623000
     *                 APLGMA, A     , BETA  , BEV   , BHI   ,          01624000
     *                 BLO   , BOD   , B     , C     , D1    , EPSZ  ,  01625000
     *                 FX    , F     , XX    , X     , ZM1   , ZM       01626000
      LOGICAL          QSWAP                                            01628000
      DATA       EPSZ  / 1.0D-12 /                                      01629000
      DATA       MAXTRY/      50 /                                      01630000
      X      = XX                                                       01634000
      A      = ALPHA                                                    01635000
      B      = BETA                                                     01636000
      QSWAP  = .FALSE.                                                  01637000
      APSIGB = -1.0D0                                                   01638000
      IF( X .LE. 0.0D0 ) GO TO 9000                                     01648000
      IF( ( A .LE. 0.0D0 ) .OR. ( B .LE. 0.0D0 ) ) GO TO 9000           01650000
      APSIGB = 1.0D0                                                    01652000
      IF( X .GE. 1.0D0 ) GO TO 9000                                     01656000
      IF( X .LE. ( A / ( A + B ) ) ) GO TO 10                           01662000
         X      = 1.0D0 - X                                             01664000
         A      = BETA                                                  01665000
         B      = ALPHA                                                 01666000
         QSWAP  = .TRUE.                                                01667000
  10  IF( ( X .EQ. A ) .OR. ( X .EQ. B ) ) GO TO 20                     01671000
      IF( A .EQ. ( ( B * X ) / ( 1.0D0 - X ) ) ) GO TO 20               01672000
      IF( DABS( A - ( X * ( A + B ) ) ) .LE. EPSZ ) GO TO 20            01673000
         C      = APLGMA( A + B ) + A * DLOG( X ) +                     01675000
     1            B * DLOG( 1.0D0 - X ) - APLGMA( A ) - APLGMA( B ) -   01676000
     2            DLOG( A - X * ( A + B ) )                             01677000
         IF( ( C .LT. (-36.0D0)) .AND. QSWAP ) GO TO 9000               01679000
            APSIGB = 0.0D0                                              01681000
            IF( C .LT. (-180.0D0)) GO TO 9000                           01682000
  20  APB    = A + B                                                    01686000
      ZM     = 0.0D0                                                    01687000
      ALO    = 0.0D0                                                    01688000
      BOD    = 1.0D0                                                    01689000
      BEV    = 1.0D0                                                    01690000
      BHI    = 1.0D0                                                    01691000
      BLO    = 1.0D0                                                    01692000
      AHI    = DEXP( APLGMA( APB ) + A * DLOG( X ) +                    01694000
     1              B * DLOG( 1.0D0 - X ) - APLGMA( A + 1.0D0 ) -       01695000
     2              APLGMA( B ) )                                       01696000
      FX     = AHI                                                      01698000
      F      = FX                                                       01699000
      NTRIES = 0                                                        01701000
  50  ZM1    = ZM                                                       01707000
      ZM     = ZM + 1.0D0                                               01708000
      D1     = A + ZM + ZM1                                             01709000
      AEV    = -( A + ZM1 ) * ( APB + ZM1 ) * X / D1 / ( D1 - 1.0D0 )   01710000
      AOD    = ZM * ( B - ZM ) * X / D1 / ( D1 + 1.0D0 )                01711000
      ALO    = BEV * AHI + AEV * ALO                                    01712000
      BLO    = BEV * BHI + AEV * BLO                                    01713000
      AHI    = BOD * ALO + AOD * AHI                                    01714000
      BHI    = BOD * BLO + AOD * BHI                                    01715000
      IF( BHI .EQ. 0.0D0 ) GO TO 50                                     01717000
         F      = AHI / BHI                                             01719000
         IF( DABS( ( F - FX ) / F ) .LT. EPSZ ) GO TO 100               01721000
            NTRIES  = NTRIES + 1                                        01723000
            IF( NTRIES .GT. MAXTRY ) GO TO 100                          01724000
               FX     = F                                               01726000
               GO TO 50                                                 01727000
  100 APSIGB = F                                                        01735000
      IF( QSWAP ) APSIGB = 1.0D0 - APSIGB                               01736000
 9000 RETURN                                                            01738000
      END                                                               01739000
C*****APSIGC                                                            01740000
      DOUBLE PRECISION FUNCTION APSIGC( CHISQ , DF )                    01741000
      INTEGER          IERR                                             01817000
      DOUBLE PRECISION APCGMA, CHISQ , DF    , P                        01819000
      P       = APCGMA( CHISQ / 2.0D0 , DF / 2.0D0 , IERR )             01820000
      IF( IERR .NE. 0 ) P = -1.0D0                                      01822000
      IF( IERR .EQ. 0 ) P = 1.0D0 - P                                   01823000
      APSIGC = P                                                        01825000
      RETURN                                                            01827000
      END                                                               01828000
C*****APSIGF                                                            01829000
      DOUBLE PRECISION FUNCTION APSIGF( F, DFN, DFD )                   01830000
      DOUBLE PRECISION ALPHA , APSIGB, BETA  , DFD   , DFN   ,          01918000
     *                 F     , X                                        01919000
      APSIGF  = -1.0D0                                                  01920000
      IF( ( DFN .LE. 0.0D0 ) .OR. ( DFD .LE. 0.0D0 ) ) GO TO 9000       01921000
         X      = DFD / ( DFD + F * DFN )                               01923000
         ALPHA  = DFD / 2.0D0                                           01924000
         BETA   = DFN / 2.0D0                                           01925000
         APSIGF = APSIGB( X, ALPHA, BETA )                              01929000
 9000 RETURN                                                            01931000
      END                                                               01932000
C*****APSIGN                                                            01933000
      DOUBLE PRECISION FUNCTION APSIGN( XP )                            01934000
      DOUBLE PRECISION APDERF, SQRT2 , XP                               01978000
      DATA                SQRT2/   1.414213562373095D0 /                01979000
      IF( XP.GE.0.D0 ) APSIGN=(1.0D0 + APDERF( XP / SQRT2 ))/2.0D0      01981000
      IF( XP.LT.0.D0 ) APSIGN=(1.0D0 - APDERF( -XP/ SQRT2 ))/2.0D0      01982000
      RETURN                                                            01984000
      END                                                               01985000
C*****APSIGT                                                            01986000
      DOUBLE PRECISION FUNCTION APSIGT( T , DFD )                       01987000
      DOUBLE PRECISION ALPHA , APSIGB, BETA  , DFD   , T     ,          02069000
     *                 X                                                02070000
      APSIGT  = -1.0D0                                                  02071000
      IF( DFD .LE. 0.0D0 ) GO TO 9000                                   02072000
         X      = DFD / ( DFD + T * T )                                 02074000
         ALPHA  = DFD / 2.0D0                                           02075000
         BETA   = 0.5D0                                                 02076000
         APSIGT = APSIGB( X, ALPHA, BETA )                              02080000
 9000 RETURN                                                            02082000
      END                                                               02083000
C*****ASORTD                                                            02084000
      SUBROUTINE ASORTD(DVTR,IKEY,NOB,NKEY)                             02085000
      INTEGER          II    , IKEY  , ITMP  , I     , KP1   , K     ,  02130000
     *                 LEVOT , MARK  , NKEY  , NOB1  , NOB              02131000
      DOUBLE PRECISION DTMP  , DVTR                                     02133000
C-CHR                                                                   02134000
      DOUBLE PRECISION SNAME                                            02135000
C/                                                                      02136000
C+CHR                                                                   02137000
C&    CHARACTER*8      SNAME                                            02138000
C/                                                                      02139000
      DIMENSION DVTR(NOB),IKEY(NKEY)                                    02140000
      DATA  SNAME /6HASORTD/                                            02141000
      LEVOT=0                                                           02146000
      IF(NOB.LE.1) GO TO 300                                            02149000
      NOB1=NOB-1                                                        02150000
      DO 200 I=1,NOB1                                                   02154000
      II=NOB-I                                                          02155000
      MARK=0                                                            02156000
      DO 100 K=1,II                                                     02157000
      KP1=K+1                                                           02158000
      IF(DVTR(K).LE.DVTR(KP1)) GO TO 100                                02159000
      MARK=1                                                            02160000
      DTMP=DVTR(KP1)                                                    02161000
      DVTR(KP1)=DVTR(K)                                                 02162000
      DVTR(K)=DTMP                                                      02163000
      IF(NKEY.NE.NOB) GO TO 100                                         02164000
      ITMP=IKEY(KP1)                                                    02165000
      IKEY(KP1)=IKEY(K)                                                 02166000
      IKEY(K)=ITMP                                                      02167000
  100 CONTINUE                                                          02168000
      IF(MARK.EQ.0) GO TO 300                                           02169000
  200 CONTINUE                                                          02170000
  300 CONTINUE                                                          02171000
 9800 CONTINUE                                                          02172000
      RETURN                                                            02174000
      END                                                               02175000
C*****ASORTI                                                            02176000
      SUBROUTINE ASORTI(IVTR,IKEY,NOB,NKEY)                             02177000
      INTEGER          II    , IKEY  , ITMP  , I     , KP1   , K     ,  02222000
     *                 LEVOT , MARK  , NKEY  , NOB1  , NOB   , IDTMP ,  02223000
     *                 IVTR                                             02224000
C-CHR                                                                   02225000
      DOUBLE PRECISION SNAME                                            02226000
C/                                                                      02227000
C+CHR                                                                   02228000
C&    CHARACTER*8      SNAME                                            02229000
C/                                                                      02230000
      DIMENSION IVTR(NOB),IKEY(NKEY)                                    02231000
      DATA  SNAME /6HASORTI/                                            02232000
      LEVOT=0                                                           02237000
      IF(NOB.LE.1) GO TO 300                                            02240000
      NOB1=NOB-1                                                        02241000
      DO 200 I=1,NOB1                                                   02245000
      II=NOB-I                                                          02246000
      MARK=0                                                            02247000
      DO 100 K=1,II                                                     02248000
      KP1=K+1                                                           02249000
      IF(IVTR(K).LE.IVTR(KP1)) GO TO 100                                02250000
      MARK=1                                                            02251000
      IDTMP=IVTR(KP1)                                                   02252000
      IVTR(KP1)=IVTR(K)                                                 02253000
      IVTR(K)=IDTMP                                                     02254000
      IF(NKEY.NE.NOB) GO TO 100                                         02255000
      ITMP=IKEY(KP1)                                                    02256000
      IKEY(KP1)=IKEY(K)                                                 02257000
      IKEY(K)=ITMP                                                      02258000
  100 CONTINUE                                                          02259000
      IF(MARK.EQ.0) GO TO 300                                           02260000
  200 CONTINUE                                                          02261000
  300 CONTINUE                                                          02262000
 9800 CONTINUE                                                          02263000
      RETURN                                                            02265000
      END                                                               02266000
C*****ASORTR                                                            02267000
      SUBROUTINE ASORTR(DVTR,IKEY,NOB,NKEY)                             02268000
      INTEGER          II    , IKEY  , ITMP  , I     , KP1   , K     ,  02313000
     *                 LEVOT , MARK  , NKEY  , NOB1  , NOB              02314000
      REAL             DTMP  , DVTR                                     02316000
C-CHR                                                                   02317000
      DOUBLE PRECISION SNAME                                            02318000
C/                                                                      02319000
C+CHR                                                                   02320000
C&    CHARACTER*8      SNAME                                            02321000
C/                                                                      02322000
      DIMENSION DVTR(NOB),IKEY(NKEY)                                    02323000
      DATA  SNAME /6HASORTR/                                            02324000
      LEVOT=0                                                           02329000
      IF(NOB.LE.1) GO TO 300                                            02332000
      NOB1=NOB-1                                                        02333000
      DO 200 I=1,NOB1                                                   02337000
      II=NOB-I                                                          02338000
      MARK=0                                                            02339000
      DO 100 K=1,II                                                     02340000
      KP1=K+1                                                           02341000
      IF(DVTR(K).LE.DVTR(KP1)) GO TO 100                                02342000
      MARK=1                                                            02343000
      DTMP=DVTR(KP1)                                                    02344000
      DVTR(KP1)=DVTR(K)                                                 02345000
      DVTR(K)=DTMP                                                      02346000
      IF(NKEY.NE.NOB) GO TO 100                                         02347000
      ITMP=IKEY(KP1)                                                    02348000
      IKEY(KP1)=IKEY(K)                                                 02349000
      IKEY(K)=ITMP                                                      02350000
  100 CONTINUE                                                          02351000
      IF(MARK.EQ.0) GO TO 300                                           02352000
  200 CONTINUE                                                          02353000
  300 CONTINUE                                                          02354000
 9800 CONTINUE                                                          02355000
      RETURN                                                            02357000
      END                                                               02358000
C*****ADINT
C+DEC20
C MODIFIED FOR THE DEC20 CONVERSION
C/
      FUNCTION ADINT(DP)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.
C
C  NAME     --  ADINT
C
C  PURPOSE  --  ADINT OBTAINS THE INTEGER PART OF A DOUBLE-PRECISION
C               NUMBER.  ITS FUNCTION IS EQUIVALENT TO THE INTRINSIC
C               FUNCTION DINT IF IT IS AVAILABLE
C
C  USAGE    --  RESULT =    ADINT( ... )
C
C  ARGUMENTS--
C
C    ADINT      FUNCTION NAME, RESULT IS DOUBLE PRECISION
C               THE INTEGER PART OF A DOUBLE-PRECISION NUMBER
C               (NOTE THAT ADINT IS A DOUBLE-PRECISION NUMBER)
C
C    DP         DOUBLE PRECISION SCALAR, INPUT ONLY
C               A DOUBLE-PRECISION NUMBER TO BE TRUNCATED
C
C  REMARKS  --  ADINT HAS THE SNAME FUNCTION AS DINT IF IT IS AVAILABLE
C               SOME MACHINE DOES NOT HAVE THE INTRINSIC FUNCTION DINT
C
C  SUBPROGRAMS  REQUIRED --
C               NONE
C
C  FORTRAN FUNCTIONS REQUIRED --
C               DABS  , IDINT , DSIGN
C
C  COMMON BLOCKS USED --
C               CMDCST
C
C     CMDCST    -DEPS
C
C  REFERENCES-- NONE
C
C  PROGRAMMER-- LON-MU LIU
C
C  LAST REVISED-- DECEMBER, 1981
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      DOUBLE PRECISION ADINT , D1    , D2    , DP    , DT, DINT
C
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS
C-CHR
      DOUBLE PRECISION  DBLNK
C/
C+CHR
C&    CHARACTER*8       DBLNK
C/
c     COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,
c    *                  DBLNK
C+IBM
C+DEC20
c     DT=DABS(DP)+DEPS
c     IF(DT.GE.1.D17) GO TO 100
c     D1=DT/1.0D8
c     D1=IDINT(D1)
c     D2=DT-D1*1.0D8
c     D2=IDINT(D2)
c     ADINT=(D1*1.0D8+D2)*DSIGN(1.D0,DP)
c     RETURN
c 100 CONTINUE
c     ADINT=DP
C/
C-IBM
C+DEC20 DINT IS AN UNDOCUMENTED DEC FORTRAN FUNCTION,
C IT MUST BE DECLARED DOUBLE PRECISION IF WE WANT TO USE IT.
      ADINT=DINT(DP)
C/
      RETURN
      END
C*****APLGMA                                                            00188000
      DOUBLE PRECISION FUNCTION APLGMA( ARG )                           00189000
      INTEGER          IHI   , ILO   , IOF   , I                        00271000
      DOUBLE PRECISION ADINT , ALINC , ARG   , BOT   , FRAC  ,          00273000
     *                 PI    , P     , Q     , RARG  , RINF  , RMAX  ,  00274000
     *                 SCALE , TOP   , XLGS2P, ZETA                     00275000
      LOGICAL          QMINUS                                           00277000
      DIMENSION P( 29 ), Q( 24 )                                        00278000
      DATA       P(  1 )/  4.12084318584770D+00 /                       00280000
      DATA       P(  2 )/  8.56898206283132D+01 /                       00281000
      DATA       P(  3 )/  2.43175243524421D+02 /                       00282000
      DATA       P(  4 )/ -2.61721858385614D+02 /                       00283000
      DATA       P(  5 )/ -9.22261372880152D+02 /                       00284000
      DATA       P(  6 )/ -5.17638349802321D+02 /                       00285000
      DATA       P(  7 )/ -7.74106407133295D+01 /                       00286000
      DATA       P(  8 )/ -2.20884399721618D+00 /                       00287000
      DATA       P(  9 )/  5.15505761764082D+00 /                       00289000
      DATA       P( 10 )/  3.77510679797217D+02 /                       00290000
      DATA       P( 11 )/  5.26898325591498D+03 /                       00291000
      DATA       P( 12 )/  1.95536055406304D+04 /                       00292000
      DATA       P( 13 )/  1.20431738098716D+04 /                       00293000
      DATA       P( 14 )/ -2.06482942053253D+04 /                       00294000
      DATA       P( 15 )/ -1.50863022876672D+04 /                       00295000
      DATA       P( 16 )/ -1.51383183411507D+03 /                       00296000
      DATA       P( 17 )/ -1.03770165173298D+04 /                       00298000
      DATA       P( 18 )/ -9.82710228142049D+05 /                       00299000
      DATA       P( 19 )/ -1.97183011586092D+07 /                       00300000
      DATA       P( 20 )/ -8.73167543823839D+07 /                       00301000
      DATA       P( 21 )/  1.11938535429986D+08 /                       00302000
      DATA       P( 22 )/  4.81807710277363D+08 /                       00303000
      DATA       P( 23 )/ -2.44832176903288D+08 /                       00304000
      DATA       P( 24 )/ -2.40798698017337D+08 /                       00305000
      DATA       P( 25 )/  8.06588089900001D-04 /                       00307000
      DATA       P( 26 )/ -5.94997310888900D-04 /                       00308000
      DATA       P( 27 )/  7.93650067542790D-04 /                       00309000
      DATA       P( 28 )/ -2.77777777688189D-03 /                       00310000
      DATA       P( 29 )/  8.33333333333330D-02 /                       00311000
      DATA       Q(  1 )/  1.00000000000000D+00 /                       00314000
      DATA       Q(  2 )/  4.56467718758591D+01 /                       00315000
      DATA       Q(  3 )/  3.77837248482394D+02 /                       00316000
      DATA       Q(  4 )/  9.51323597679706D+02 /                       00317000
      DATA       Q(  5 )/  8.46075536202078D+02 /                       00318000
      DATA       Q(  6 )/  2.62308347026946D+02 /                       00319000
      DATA       Q(  7 )/  2.44351966250631D+01 /                       00320000
      DATA       Q(  8 )/  4.09779292109262D-01 /                       00321000
      DATA       Q(  9 )/  1.00000000000000D+00 /                       00323000
      DATA       Q( 10 )/  1.28909318901296D+02 /                       00324000
      DATA       Q( 11 )/  3.03990304143943D+03 /                       00325000
      DATA       Q( 12 )/  2.20295621441566D+04 /                       00326000
      DATA       Q( 13 )/  5.71202553960250D+04 /                       00327000
      DATA       Q( 14 )/  5.26228638384119D+04 /                       00328000
      DATA       Q( 15 )/  1.44020903717009D+04 /                       00329000
      DATA       Q( 16 )/  6.98327414057351D+02 /                       00330000
      DATA       Q( 17 )/  1.00000000000000D+00 /                       00332000
      DATA       Q( 18 )/ -2.01527519550048D+03 /                       00333000
      DATA       Q( 19 )/ -3.11406284734067D+05 /                       00334000
      DATA       Q( 20 )/ -1.04857758304994D+07 /                       00335000
      DATA       Q( 21 )/ -1.11925411626332D+08 /                       00336000
      DATA       Q( 22 )/ -4.04435928291436D+08 /                       00337000
      DATA       Q( 23 )/ -4.35370714804374D+08 /                       00338000
      DATA       Q( 24 )/ -7.90261111418763D+07 /                       00339000
      DATA       RMAX  / 1.0D+36 /                                      00342000
      DATA       RINF  / 1.0D+38 /                                      00344000
      DATA       ZETA  / 1.0D-14 /                                      00346000
      DATA       XLGS2P/ 9.18938533204673D-01 /                         00348000
      DATA       PI    / 3.141592653589793D+00 /                        00350000
      APLGMA = RINF                                                     00354000
      SCALE  = 1.0D0                                                    00355000
      ALINC  = 0.0D0                                                    00356000
      FRAC   = 0.0D0                                                    00357000
      RARG   = ARG                                                      00358000
      IOF    = 1                                                        00359000
      QMINUS = .FALSE.                                                  00360000
      IF( RARG .LT. 0.0D0 ) GO TO 10                                    00364000
      IF( RARG .EQ. 0.0D0 ) GO TO 9000                                  00365000
    5 IF( RARG .LE. 0.5D0 ) GO TO 20                                    00366000
      IF( RARG .LE. 1.5D0 ) GO TO 30                                    00367000
      IF( RARG .LE. 4.0D0 ) GO TO 40                                    00368000
      IF( RARG .LE. 12.0D0 ) GO TO 50                                   00369000
      IF( RARG .LE. RMAX   ) GO TO 120                                  00370000
      GO TO 9000                                                        00371000
  10  QMINUS = .TRUE.                                                   00375000
      RARG   = -RARG                                                    00376000
      TOP    = ADINT( RARG )                                            00377000
      BOT    = 1.0D0                                                    00378000
      IF( DMOD( TOP , 2.0D0 ) .EQ. 0.0D0 ) BOT = -1.0D0                 00379000
      TOP    = RARG - TOP                                               00380000
      IF( TOP .EQ. 0.0D0 ) GO TO 9000                                   00381000
         FRAC   = BOT * PI / DSIN( TOP * PI )                           00383000
         RARG   = RARG + 1.0D0                                          00384000
         FRAC   = DLOG( DABS( FRAC ) )                                  00385000
         GO TO 5                                                        00386000
  20  ALINC  = -DLOG( RARG )                                            00390000
      SCALE  = RARG                                                     00391000
      RARG   = RARG + 1.0D0                                             00392000
      IF( SCALE .GE. ZETA ) GO TO 100                                   00394000
         APLGMA = ALINC                                                 00396000
         GO TO 9000                                                     00397000
  30  SCALE  = RARG - 1.0D0                                             00401000
      GO TO 100                                                         00402000
  40  SCALE  = RARG - 2.0D0                                             00406000
      IOF    = 9                                                        00407000
      GO TO 100                                                         00408000
  50  IOF    = 17                                                       00412000
  100 ILO    = IOF + 1                                                  00421000
      IHI    = IOF + 7                                                  00422000
      TOP    = P( IOF )                                                 00424000
      BOT    = Q( IOF )                                                 00425000
      DO 110 I = ILO , IHI                                              00427000
         TOP    = TOP * RARG + P( I )                                   00428000
         BOT    = BOT * RARG + Q( I )                                   00429000
  110 CONTINUE                                                          00430000
      APLGMA = SCALE * ( TOP / BOT ) + ALINC                            00432000
      GO TO 1000                                                        00433000
 120  ALINC  = ( RARG - 0.5D0 ) * DLOG( RARG ) - RARG + XLGS2P          00437000
      SCALE  = 1.0D0 / RARG                                             00438000
      RARG   = SCALE * SCALE                                            00439000
      TOP    = P( 25 )                                                  00441000
      DO 130 I = 26 , 29                                                00442000
         TOP    = TOP * RARG + P( I )                                   00443000
  130 CONTINUE                                                          00444000
      APLGMA = SCALE * TOP + ALINC                                      00446000
 1000 IF( QMINUS ) APLGMA = FRAC - APLGMA                               00448000
 9000 RETURN                                                            00450000
      END                                                               00451000
