c******************************************************************
c****
c**** General Information
c**** Modified from soz4_u44.f, for 1 or 2 trends (trend or trend + change_slope)
c**** Read single-column file (excluding year and month)
c**** 1 is nonzero since 1970, for only 1 single column data besides year and month

c**** in par1 file specify all parameters like number of regressors, inflection time etc.
c**** n1: number of months covered by the data(for 1 layer); 2 step regression included
c**** n2: number of regression parameters
c**** n3: number of parameters, including AR coeficient
c**** n4: number of missing blocks
c**** n5: maximal number of missing observation in one missing block
c**** n01: number of months covered by the data(whole data set)
c**** m1: number of non-missing observations(for 1 layer)
c****
c**** The previous version of this program is 'soz20sar.f',
c**** Modified by Lan and XZ in June 98
c******************************************************************

      program final
      double precision x(1000,50),y(1000),u(1000),v(1000),
     1     xts(1000,50),idata(1000,20),b(50),sgmw(12),
     1     trend(180,20),std(180,20),firstx(1000),
     l     ssq,sss,ssq1,stp,s

      integer bmis(100),nmis(100),year(1000,3),month(1000,3),
     l     season(1000),id1(-1:20),kb(20),nmt(12),
     1     i,j,irn,ip,flag,mstp,ARORDER
      character*8 level(15)
      character*32 title(32)

c**** modified 1
      INTEGER  IDCORR, IDITER, ITYMDL, NPROB, NOB, NP,
     *     MIT, NOBVAR, MXNOBS, NOVARS, MDLROW, NOPARS,
     *     IDWGHT

      CHARACTER*8      LIBNAH, SUBNAH
      DOUBLE PRECISION EPS1, EPS2, FLAM, FNU,VMSE
      DOUBLE PRECISION TH(100),DIFZ(100),Q(100),P(100),E(100),PHI(20),
     *     TB(100),A(100,100),D(100,100),DELZ(1000,100),R(1000),
     *     YXDATA(1000,100),WGTVAR(1000),MDLVR2(10,100),
     *     PARMTR(100)
      DIMENSION NOBVAR(100)
      COMMON / BASIC / ICMDIN,ICMDOUT,IPRT
      COMMON / DATA  / ARORDER

      common season/bn/bmis,nmis/s/sgmw/nn/n4,n5,n2,ip

      ICMDIN=5
      ICMDOUT=6
      IPRT=8
      MDLROW=10

      call initialize(stp,xts,idata,id1,kb,year,month)
      call setlevel(level)

      n01=12*kb(4)+kb(3)-kb(1)-12*kb(2)+1
      flag=kb(10)
      mstp=kb(11)

      nk = 1

         do 100 i=1,n01
            year(i,2)=year(i,1)
            month(i,2)=month(i,1)
            y(i)=idata(i,1)*1.0
 100     continue


 2000    continue

         m1=0
         do 200 i=1,n01
            if(year(i,2).eq.0)goto 210
            if(y(i).ne.-990.and.year(i,2).ne.-9) then
               m1=m1+1
               year(m1,2)=year(i,2)
               month(m1,2)=month(i,2)
               y(m1)=y(i)
            endif
 200    continue
 210    continue

        do 220 i=m1+1,n01
           y(i)=0.0
           month(i,2)=0
           year(i,2)=0
 220    continue

        n1=12*year(m1,2)+month(m1,2)-month(1,2)-12*year(1,2)+1
        n12=12*(year(1,2)-kb(2))+month(1,2)-1

	if ( (kb(6).ne.0).and.(id1(1).eq.1) ) then
           n2=kb(5)+kb(15)+1
           write(9,*)'Level ', level(1)
           write(9,*) ' '
           write(9,*) 'Intevention(yea=1,no=0): ',1
        else
           n2=kb(5)+kb(15)
           write(9,*)'Level ', level(1)
           write(9,*) ' '
           write(9,*) 'Intevention(yea=1,no=0): ',0
        endif

        do 300 i=1,n01
           do 310 j=1,n2
              yxdata(i,j+1)=xts(n12+i,j)
 310       continue
 300    continue


        do 320 i=1,4
           nmt(i)=0
 320    continue

        n12=12*(year(1,2)-year(1,1))+month(1,2)-month(1,1)
        do 330 i=1,n01
           K=int(MOD(month(i,2),12)/3)+1
           nmt(K)=nmt(K)+1

           year(i,3)=year(n12+i,1)
           month(i,3)=month(n12+i,1)
           season(i)=int(MOD(month(i,3),12)/3)+1
 330    continue

        n14=min(nmt(1),nmt(2),nmt(3),nmt(4))
        write(9, *) ' '
        write(9,*)'From: ',year(1,2),' /',month(1,2),
     1       '    To: ', year(m1, 2),' /',month(m1,2)
        write(9,*) 'Number of available observation: ', m1
        write(9,*) 'Number of missing :              ',n1-m1


        if(m1.lt.50.or.n14.lt.3) then
           call settrend(1, trend, std)
        else

           call prog2(n1,year,month)
           do 400 i=1,n1
              yxdata(i,1)=0.0
 400       continue
C           call prog3(n1,x,y,yxdata)
C
C           do 401 i = 1, m1
C
C               firstx(i) = x(i, n2)
C
C 401       continue
C
C           call lls(firstx,y,b,e,u,v,m1,1,1000,50)
C
C           do 402 i=1,n1
C
C              yxdata(i,1)=0.0
C
C 402       continue
C
C           do 403 i = 1, m1
C
C               y(i) = u(i)
C
C 403       continue
C
C           n2=n2-1

           call prog3(n1,x,y,yxdata)
           call lls(x,y,b,e,u,v,m1,n2,1000,50)
           call getric(b,e,trend,std,1,id1(1),3)
c     call pacf(u,m1,pf)

           ip=kb(16)
           n3=n2+ip
           n10=n1-ip

           call aut(y,v,phi,m1,ip)
           do 450 i=1,ip
              write(6,451) i, phi(i)
 450       continue
 451       format(//8x,'the initial phi ',i2,'  =',4x,f10.3)

           do 460 i=1,n2
              th(i)=b(i)
 460       continue
           do 470 i=1,ip
              th(n2+i)=phi(i)
 470       continue
           write(9, *) 'Numer of missing blocks:         ', n4
           write(9, *) 'Maximal missing in one block:    ',n5
           write(9, *)
           call output100(9,0,th,e,1,kb)

           irn=0
           ssq=1.0

 3000      continue

           if(flag.eq.0) then
              do 500 i=1,4
                 sgmw(i)=1.0
 500          continue
            else
               call weight(th,n10,n3,sgmw,yxdata)
            endif

            ssq1=ssq
            ARORDER=ip
            IDCORR=1
            IDITER=1
            ITYMDL=2
            IDWGHT=0
            LIBNAH(1:8)='LIBNAH  '
            SUBNAH(1:8)='SUBNAH  '
            NPROB=1
            NP=n2+ip
            EPS1=0.0000001D0
            EPS2=0.00001D0
            MIT=100
            FLAM=0.01D0
            FNU=10.0D0
            MXNOBS=n1
            NOB=n1
            NOVARS=n2+ip
            NOPARS=NP

            DO 301 I=1,n2+ip
               NOBVAR(I)=1000
               DIFZ(I)=0.00001D0
               MDLVR2(1,I)=1000
               MDLVR2(2,I)=th(i)
               MDLVR2(3,I)=0.0D0
               MDLVR2(4,I)=0.0D0
               MDLVR2(5,I)=0.0D0
               MDLVR2(6,I)=I
               MDLVR2(7,I)=I
               MDLVR2(8,I)=0.0D0
               MDLVR2(9,I)=0.0D0
               MDLVR2(10,I)=0.0D0
 301        CONTINUE


 7000       CALL NLNBGM(IDCORR,IDITER,ITYMDL,LIBNAH,SUBNAH,
     *           NPROB,NOB,NP,EPS1,EPS2,MIT,FLAM,FNU,TH,
     *           DIFZ,Q,P,E,PHI,TB,A,D,DELZ,R,YXDATA,
     *           IDWGHT,WGTVAR,NOBVAR,MXNOBS,NOVARS,PARMTR,
     *           MDLVR2,MDLROW,NOPARS,VMSE)

            ssq=0.0
            do 600 i=1,n1
               ssq=ssq+r(i)**2
 600        continue
            do 610 i=1,n2
               b(i)=th(i)
 610        continue
            do 620 i=1,ip
               phi(i)=th(n2+i)
 620        continue
            irn=irn+1
            sss=abs(ssq1-ssq)/ssq1


            if (flag.eq.0) then
               sg1=ssq/(n1-n3)
               do 650 j=1,n1
                  r(j)=r(j)/sqrt(sg1)
 650           continue
               goto 700
            endif

            write(6,*)'iteration no = ',irn,' dSSE = ',sss
            write(9,*)'iteration no = ',irn,' SSQ = ', ssq,
     1           ' dSSE(%) = ',sss

            if(stp.lt.sss.and.irn.lt.mstp) goto 3000
*     stopping rule using objective fn and iteration No.
 700        write(7,1031) irn
 1031       format(//8x,'iterative No:',i6//)

            write(6, *) 'var before = ', ssq1, ' var = ',ssq
            write(9, *) 'var before = ', ssq1, ' var = ',ssq

            write(6,*)'before check irflag = ',irflag

            irflag=0
            do 800 i=1,m1
               j=12*(year(i,2)-year(1,2))+month(i,2)-month(1,2)+1
               if(abs(r(j)).gt.3.0) then
                  irflag=irflag+1
                  write(9,*)'outlier position = ',i,' ',
     1                 year(i,2),' /',month(i,2)
                  write(6,*)'irpos = ',i,' ',year(i,2),'/',month(i,2)
                  year(i,2)=-9
               endif

 800        continue

            iriter=iriter+1
            if(irflag.ne.0) goto 2000

            call getric(b,e,trend,std,1,id1(1),1)
            call output100(9,1,th,e,1,kb)
            call output200(16,1,n1,m1,x,y,b,R,year,month)


         endif

         do 900 i=1,np
            write(18,905)(d(i,j),j=1,i)
 900     continue
 905     format(30(f8.3,2x))

         do 910 i=13,16
            write(51,905) (d(i,j),j=13,13)
 910     continue

         write(6, *) ' '
         write(6, *) ' '
         write(6, *) '        ', level(1)
         write(6, *) ' '
         write(6, *) ' '

         title(1)='     level      INTERVN(LS)                STD ERR '
         title(2)='     level      INTERVN(ML)                STD ERR '
         title(3)='     level      QBO(LS)                STD ERR '
         title(4)='     level      QBO(ML)                STD ERR '
         title(5)='     level      SOLAR(LS)                STD ERR '
         title(6)='     level      SOLAR(ML)                STD ERR '

         call output10(nk,3,4,0,trend,std,level)
         call output10(nk,1,2,1,trend,std,level)

         if(kb(6).ne.0) then
            call output11(12,nk,10,0,id1,level,trend,std,title(1))
            call output11(12,nk,6,0,id1,level,trend,std,title(2))
         endif
c#absolute for the 1st two, rel. for the last two
         call output11(15,nk,12,1,id1,level,trend,std,title(3))
         call output11(15,nk,8,1,id1,level,trend,std,title(4))
         call output11(14,nk,11,1,id1,level,trend,std,title(5))
         call output11(14,nk,7,1,id1,level,trend,std,title(6))

 8100    format(//8x, 'Missing Blocks = ',i3,18x, 'MaxMissing = ', i3//)

         stop
         end



        subroutine aut(y,v,phi,n1,ip)
*       for AR(ip) par
        double precision y(1000),v(1000),u(1000),u1(1000),u2(1000,30)
        double precision phi(20),uu(30,30),u12(30)
        do 398 i=1,n1
        u(i)=y(i)-v(i)
  398   continue
        do 7500 i=1,n1-ip
        u1(i)=u(i+ip)
        do 7502 j=1,ip
          u2(i,j)=u(i+ip-j)
 7502   continue
 7500   continue
        do 7504 i=1,ip
        do 7505 j=1,ip
        uu(i,j)=0.0
        do 7509 k=1,n1-ip
 7509      uu(i,j)=uu(i,j)+u2(k,i)*u2(k,j)
 7505   continue
 7504   continue
        call gsweep(uu,ip,30)
        do 7510 i=1,ip
        u12(i)=0.0
        do 7512 j=1,n1-ip
 7512   u12(i)=u12(i)+u2(j,i)*u1(j)
 7510   continue
        do 7514 i=1,ip
        phi(i)=0.0
        do 7516 j=1,ip
 7516   phi(i)=phi(i)+uu(i,j)*u12(j)
 7514   continue
        return
        end

        subroutine gsweep(a,kt,ks)
*       a ks by ks, calculate left up kt by kt matrix's inverse
        double precision a(ks,ks)
        do 500 k=1,kt
        a(k,k)=1/a(k,k)
        do 502 i=1,kt
        do 504 j=1,kt
        if(i.eq.k.or.j.eq.k) goto 504
        a(i,j)=a(i,j)-a(i,k)*a(k,j)*a(k,k)
  504   continue
  502   continue
        do 506 i=1,kt
        if(i.eq.k) goto 506
        a(i,k)=-a(i,k)*a(k,k)
        a(k,i)=a(k,i)*a(k,k)
  506   continue
  500   continue
        do 2150 i=kt+1,ks
        do 2152 j=1,ks
        a(i,j)=0.0
 2152   continue
 2150   continue
        do 2154 i=1,kt
        do 2156 j=kt+1,ks
        a(i,j)=0.0
 2156   continue
 2154   continue
        return
        end


        subroutine weight(b1,n10,n3,sgm,yxdata)
*       weights correponding the 12 months
        double precision f(1000),b1(50),yxdata(1000,100),
     l  sgm(12),sum(12),ye1,ye2
        integer season(1000),number(12),bmis(100),nmis(100),n4
        common season/bn/bmis,nmis/nn/n4,n5,n2,ip

        ye1=0.0
        do 580 j=1,n3-1
        ye1=ye1+b1(j)*yxdata(1,j+1)
  580   continue
        do 600 i=2,n10+1
        ye2=0.0
        do 602 j=1,n3-1
        ye2=ye2+b1(j)*yxdata(i,j+1)
  602   continue
        f(i)=yxdata(i,1)-ye2-b1(n3)*(yxdata(i-1,1)-ye1)
        ye1=ye2
  600   continue


        do 1020 k=1,4
        sgm(k)=0.0
        sum(k)=0.0
        number(k)=0
 1020   continue
        do 1022 i=1,4
        do 1024 k=2,n10+1
        do 1023 j=1,n4
        do 1025 jj=bmis(j),bmis(j)+nmis(j)
        if(k.eq.jj) goto 1024
 1025   continue
 1023   continue
        if(season(k).ne.i) goto 1024
        sum(i)=sum(i)+f(k)
        sgm(i)=sgm(i)+f(k)*f(k)
        number(i)=number(i)+1
 1024   continue
 1022   continue
        do 1026 i=1,4
	if(number(i).lt.1) goto 1026
        sgm(i)=sgm(i)-sum(i)**2/number(i)
        sgm(i)=sgm(i)/number(i)
 1026   continue
        do 1027 i=1,4
	if(sgm(i).le.0.0) sgm(i)=1.0
 1027   continue
        return
        end


	subroutine pacf(u,n,phi)
	double precision u(1000),phi(20), r0(20),r(20,20),ro(20)
	double precision rr(20,20),r1(20)
ccc     u is the input series,n is the length of u, phi is the pacf
	kmax=20
	call acf(u,n,ro)
	do 1200 k=1,kmax
	phi(k)=0.0
		do 1202 i=1,kmax
		do 1204 j=1,kmax
		rr(i,j)=0.0
 1204           r(i,j)=0.0
		r1(i)=0.0
 1202           r0(i)=0.0
		do 1206 i=1,k
		do 1208 j=1,k
			if(j.lt.i)then
				r(i,j)=ro(i-j)
			else if(i.lt.j)then
				r(i,j)=ro(j-i)
			else
				r(i,j)=1.0
			endif
 1208           continue
 1206               r0(i)=ro(i)
		do 1210 i=1,k
		do 1212 j=1,k
		do 1214 ij=1,k
 1214                       rr(i,j)=rr(i,j)+r(ij,i)*r(ij,j)
 1212                   r1(i)=r1(i)+r(j,i)*r0(j)
 1210           continue
		call gsweep(rr,k,20)
		do 1216 i=1,k
 1216           phi(k)=phi(k)+rr(k,i)*r1(i)
 1200   continue
	return
        end


	subroutine acf(u,n,ro)
	double precision u(1000),ro(20),r,r1,m1,m2,r2
ccccc   ro is the acf of the series u, n is the length of u
	kmax=20
	do 2001 k=1,kmax
        r=0.0
        r1=0.0
        r2=0.0
        m1=0.0
        m2=0.0
	do 2002 i=1,n-k
	m2=m2+u(i+k)
2002    m1=m1+u(i)
	m1=m1/(n-k)
	m2=m2/(n-k)
	do 2000 ii=1,n-k
	r=r+(u(ii)-m1)*(u(ii+k)-m2)
	r1=r1+(u(ii)-m1)**2
 2000   r2=r2+(u(ii+k)-m2)**2
	ro(k)=r/sqrt(r1*r2)
 2001   continue
	return
        end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine prog2(n1,year,month)

      integer month(1000,3),year(1000,3),bmis(100),nmis(100)
      common /bn/bmis,nmis/nn/n4,n5,n2,ip

      k2=0
      k3=0
      n4=0
      n5=0

      do 10 i=1,100
         bmis(i)=0
         nmis(i)=0
 10   continue

      do 100 i=1, n1-1
         if(month(i+1,2).ne.0) then
            k1=12*(year(i+1,2)-year(i,2))
     1           +month(i+1,2)-month(i,2)-1
            if(k1.ne.0) then
               n4=n4+1
               n5=max(n5,k1)
               nmis(n4)=k1
               bmis(n4)=i+1+k2
               k2=k2+k1
            endif
         endif
 100  continue

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine settrend(ik,trend,std)

      integer i,j,ik
      double precision trend(180,20),std(180,20)

      do 10 i=1,4
         do 15 j=1,5
            trend(i+(ik-1)*4,j)=99.9
            std(i+(ik-1)*4,j)=99.9
 15      continue
         trend(i+(ik-1)*4,20)=99.9
 10   continue

      do 20 j=6,13
         trend(ik,j)=99.9
         std(ik,j)=99.9
 20   continue

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine output10(nk,i1,i2,ind,trend,std,level)

      integer nk, i1,i2,ind
      double precision trend(180,20),std(180,20)
      character*8 level(15)
      character*32 title

      if(ind.eq.0) then
         title = '         The LS Trend Estimates'
      else
         title = '         The ML Trend Estimates'
      endif

      write(7,*) ' '
      write(7,*) ' '
      write(7,*) ' '
      write(7,*) ' '
      write(7,*) title
      write(7,*) ' '
      write(7,*) ' '
      write(7,*) '     level    Estimated Trend          STD ERR '
      write(7,*) ' '
      do 10 i=1,nk
         do 15 j=1,4
            write(7,100) level(i),trend(j+(i-1)*4,i1),std(j+(i-1)*4,i1)
            if(ind.eq.0) then
               write(20,300)i,trend(j+(i-1)*4,20)
               write(11,200)i,trend(j+(i-1)*4,3),std(j+(i-1)*4,3)
            else
               write(11,200) i,trend(j+(i-1)*4,1),std(j+(i-1)*4,1)
               write(13,200) i,trend((j-1)*3+1+(i-1)*12,5),
     1              std((j-1)*3+1+(i-1)*12,5)
               write(13,200) i,trend((j-1)*3+2+(i-1)*12,5),
     1              std((j-1)*3+2+(i-1)*12,5)
               write(13,200) i,trend((j-1)*3+3+(i-1)*12,5),
     1              std((j-1)*3+3+(i-1)*12,5)
            endif
 15      continue
 10   continue
      write(7,*) '     level    Relative Trend          STD ERR '
      write(7,*) ' '
      do 20 i=1,nk
         do 25 j=1,4
            write(7,100) level(i),trend(j+(i-1)*4,i2),std(j+(i-1)*4,i2)
            write(11,200) i,trend(j+(i-1)*4,i2),std(j+(i-1)*4,i2)
 25      continue
 20   continue

 100  format(5x,a4,10x,f10.4,12x,f8.4)
 200  format(5x,i4,10x,f10.4,12x,f10.4)
 300  format(5x,i4,10x,f10.3)

      return
      end





      subroutine output11(file,nk,i1,ind,id1,level,trend,std,title)

      integer nk,i1,ind,file,id1(-1:20)
      double precision trend(180,20),std(180,20)
      character*8 level(15)
      character*32 title



      write(7,*) ' '
      write(7,*) ' '
      write(7,*) title
      write(7,*) ' '

      do 10 i=1,nk
         if((ind.eq.1).or.(id1(i).eq.1)) then
            write(7,100) level(i),trend(i,i1),std(i,i1)
            write(file,200) i,trend(i,i1),std(i,i1)

         endif
 10   continue

 100  format(5x,a4,10x,f10.5,12x,f8.5)
 200  format(5x,i4,10x,f10.5,12x,f10.5)

      return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c**** k=1, (1,2,6,7,8)(new) <--> (1,2,7,8,10)
c**** k=3, (3,4,10,11,1)(new) <--> (3,4,6,9,11)(old)
c**** ind=id1(ik), teh intervention indicator
c**** ik, the layer indicator

      subroutine getric(b,e,trend,std,ik,ind,k)
      integer i,j,ik,ind,k
      double precision a1,a2,ric,b(50),e(100),
     1     trend(180,20),std(180,20)
      common /nn/n4,n5,n2,ip
      a1 = ind*1.2
      a2 = ind*1.0 + (1-ind)*1.2
cc This part is for relative trend
      do 20 i=1,4

         j=3*(i-1)
         if(i.eq.1) j=12


         ric=b(3*(i-1)+1)+ b(3*(i-1)+2)+b(j)
         ric=ric/3 + b(n2-1)*a1 + b(n2)*a2

         ric=abs(ric)

         trend(i+(ik-1)*4,k)=b(12+i)
         trend(i+(ik-1)*4,k+1)=b(12+i)/ric*100
         std(i+(ik-1)*4,k)=e(12+i)
         std(i+(ik-1)*4,k+1)=e(12+i)/ric*100

         if(k.eq.3) then
            trend(i+(ik-1)*4,20)=ric
         else
            do 10 j=1,3
               trend((i-1)*3+j+(ik-1)*12,5)=
     1              b((i-1)*3+j)+b(n2-1)*a1+b(n2)*a2
               std((i-1)*3+j+(ik-1)*12,5)=e((i-1)*3+j)
 10         continue

         endif

 20   continue

      ric=0
      do 100 i=1,12
         ric=ric+b(i)
 100  continue

      ric=abs(ric/12+b(n2-1)*a1+b(n2)*a2)

      trend(ik,2*k+4)=b(n2)*ind
      std(ik,2*k+4)=e(n2)*ind
      trend(ik,2*k+5)=b(n2-ind)/ric*100
      std(ik,2*k+5)=e(n2-ind)/ric*100
      trend(ik,2*k+6)=b(n2-1-ind)
      std(ik,2*k+6)=e(n2-1-ind)

      return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c**** update yxdata and x according to y

      subroutine prog3(n1,x,y,yxdata)

      integer bmis(100),nmis(100)
      double precision yxdata(1000,100),x(1000,50),y(1000)

      common season/bn/bmis,nmis/nn/n4,n5,n2,ip

      n44=n1
      if(n4.ne.0) n44=bmis(1)-1

      do 20 i=1,n44
         yxdata(i,1)=y(i)
         do 22 j=1,n2
            x(i,j)=yxdata(i,j+1)
 22      continue
 20   continue

      if(n4.ne.0) then
         do 200 k=1,n4
            jn=0
            do 30 l=1,k
               jn=jn+nmis(l)
 30         continue
            n44=bmis(k+1)-1
            if(k.eq.n4) n44=n1

            do 40 i=bmis(k)+nmis(k),n44
               yxdata(i,1)=y(i-jn)
               do 45 jj=1,n2
                  x(i-jn,jj)=yxdata(i,jj+1)
 45            continue
 40         continue

 200     continue
      endif

      return
      end
************************************************************
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine openoutput
*     all output file, starting from 11, ending at most 99
*     input files can be anything but 6,8,10
*     unit 3,4 is reserved for temporary input

      open(unit=7,file='t.out',status='unknown')
      open(unit=8,file='t1.out',status='unknown')
      open(unit=9,file='s1.out',status='unknown')
      open(unit=11,file='s.out',status='unknown')
      open(unit=12,file='intervn.out',status='unknown')
      open(unit=13,file='intercp.out',status='unknown')
      open(unit=14,file='solar.out',status='unknown')
      open(unit=15,file='qbo.out',status='unknown')
      open(unit=16,file='resid.out', status='unknown')
      open(unit=17,file='matrix.out', status='unknown')
      open(unit=18,file='covar.out', status='unknown')
      open(unit=19,file='xmatrix.out',status='unknown')
      open(unit=20,file='sconst.out',status='unknown')
C       open(unit=30,file='solarcoeff.out',status='unknown')
      open(unit=31,file='coeff.out',status='unknown')

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine xmatrix(kb,f107,xts,inf_time)

*     calculate design matrix (xts)
*     inputs: kb, f107,inf_time

      integer kb(20),inf_time(2)
      double precision f107(1000,10),xts(1000,50)
      double precision meanao(10)

      n2=kb(5)+kb(15)
      K1=12*(kb(4)-kb(2)+1)

      DO 20 I=1,K1
         if (kb(5).le.3) then
            K = 1
         else if (kb(5).ge.12) then
            K = MOD(I,12)
            IF(K.EQ.0) K=12
         end if

         DO 22 J=1,kb(5)
            xts(I,J)=0.0
 22      CONTINUE
         xts(I,K)=1.0

 20   CONTINUE

      if ( kb(5).eq.2.or.kb(5).eq.3.or.kb(5).ge.13 ) then
          break0= 70

          n202 = 1
         if (kb(2).eq.break0.and.n202.eq.1.or.(kb(2).gt.break0)) then
    
             K20=1
    
             K30=(kb(2)-break0)*12-n202+1
    
         else
    
             K20=12*(break0-kb(2))+n202
    
             K30=0
    
         endif
    
          DO 29 I=K20,K1
          
             if (kb(5).eq.2.or.kb(5).eq.13) then
                 K0 = kb(5)
             else if (kb(5).eq.3.or.kb(5).eq.14) then
                 K0 = kb(5) - 1
             endif
             xts(I,K0)=1.0*(I+K30-K20+1)/12.0
 29       CONTINUE
          write(9,*)'position of 01/70 = ',K20
      endif


      if ( kb(5).eq.3.or.kb(5).eq.14 ) then
          break= inf_time(1)

          n202 = inf_time(2)
         if (kb(2).eq.break.and.n202.eq.1.or.(kb(2).gt.break)) then
             K2=1
             K3=(kb(2)-break)*12-n202+1
        else
             K2=12*(break-kb(2))+n202
             K3=0
         endif
          DO 30 I=K2,K1
             K = kb(5)
             xts(I,K)=1.0*(I+K3-K2+1)/12.0
 30       CONTINUE
          write(9,*)'position of ',n202, '/',inf_time(1),' = ',K2
      endif

      write(9,*)'position of last =',K1
      do 31 i = 1, kb(15)
          meanao(i) = 0
          do 32 j = 1, K1
              meanao(i) = meanao(i) + f107(j, i)
32        continue
          meanao(i) = meanao(i)/K1
          if ( abs(meanao(i)) < 100 ) meanao(i) = 0
31    continue

      do 40 i=1,K1

         do 41 j=1,kb(15)
             xts(i,kb(5)+j)=f107(i,j) - meanao(j)
41       continue

40    continue

      n01=12*kb(4)+kb(3)-kb(1)-12*kb(2)+1
c	do 3500 i=1,n01
c	write(19, *) xts(i,1),xts(i,2),xts(i,3),xts(i,4),xts(i,5),
c	1	xts(i,6),xts(i,7),xts(i,8),xts(i,9),xts(i,10),xts(i,11),
c	1	xts(i,12),xts(i,13),xts(i,14),xts(i,15),xts(i,16),xts(i,17),
c	1	xts(i,18),xts(i,19),xts(i,20),xts(i,21)

c 3500	continue

      if (kb(6).ne.0) then
         K2=12*(kb(7)-kb(2))+kb(6)

         if(kb(8).ne.0) then
            K1=12*(kb(9)-kb(2))+kb(8)
         endif

         if (K2.gt.0) then
             do 18 i=K2,K1
                xts(i,n2+1)=1.0
 18          continue
             write(9,*)'inter position = ',K2
         endif
      endif
	do 3500 i=1,K1
	write(19, *) xts(i,1),xts(i,2),xts(i,3),xts(i,4),xts(i,5),
	1	xts(i,6),xts(i,7),xts(i,8),xts(i,9),xts(i,10),xts(i,11),
	1	xts(i,12),xts(i,13),xts(i,14),xts(i,15),xts(i,16),xts(i,17),
	1	xts(i,18),xts(i,19),xts(i,20),xts(i,21)
c	write(19, *) i,xts(i,13),xts(i,14),xts(i,15),xts(i,18),xts(i,19)

3500	continue
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine initialize(stp,xts,odata,id1,kb,year,month)

c**** All parameter are output only

      integer nob,year(1000,3),month(1000,3),id1(-1:20),kb(20),
     1      inf_time(2), lagpar
      double precision stp,odata(1000,20),f107(1000,10),
     1     xts(1000,50)

      character*20 filename, filesolar
      call openoutput

      nob=1
      open(unit=3,file='r1.dat',status='old')
 10   read(3,*,end=5) year(nob,1),month(nob,1),
     c     (odata(nob,j),j=1,1)
 2    format(1x,i2,1x,i2,22x,15(f5.1))
      nob=nob+1
      goto 10
 5    continue
      nob=nob-1
      kb(1)=month(1,1)
      kb(2)=year(1,1)
      kb(3)=month(nob,1)
      kb(4)=year(nob,1)
      n1=12*kb(4)+kb(3)-kb(1)-12*kb(2)+1

      n3=(kb(4)-kb(2)+1)
      n4=12*n3

      close(unit=3)
      open(unit=3,file='par1.dat',status='old')
      read(3, 27) kb(5), kb(15), kb(16)


      do 71 ifile = 1, kb(15)

          read(3, *) filename

          read(3, *) lagpar

          indsolar = 1

          filesolar = 'f107-03'

          open(unit=4,file=filename,status='old')
 50       read(4,*) f107(1,ifile),i1,i2

          if ( lagpar .ge. 0 )  then

              intlagpar = kb(2)+int( abs(lagpar)/12 )

              declagpar = 1 + mod( abs(lagpar), 12 )

          else

              intlagpar = kb(2) - int( (abs(lagpar)-1)/12 )-1

              declagpar = 13 - mod( abs(lagpar), 12 )

          end if

          if ( ( i1.ne.intlagpar ).or.(i2.ne.declagpar) ) goto 50

          do 73 j = 1,7
              if ( filename(j:j) .ne. filesolar(j:j) )  then

                  indsolar = 0

              endif

 73       continue

          if ( indsolar .eq. 1 ) then

              f107(1,ifile) = f107(1,ifile) / 100

          endif

          do 55 i=2,n4
              read(4,*,end=56) f107(i,ifile)

              if ( indsolar .eq. 1 ) then

                 f107(i,ifile) = f107(i,ifile) / 100

              endif

 55       continue
 56       continue


          write(9,*) a, filename(1:7), f107(1,ifile), ' year/month =',i1,' ',i2

          close(unit=4)


 71   continue


      read(3, 24) (inf_time(j),j=1,2)

      read(3, 25) kb(6)
      read(3, 25) kb(7)
      read(3, 25) kb(8)
      read(3, 25) kb(9)
      read(3, 25) kb(10)
      read(3, 25) kb(11)

 24   format(i3,1x,i2)
 25   format(i2)
 26   format(i3)
 27   format(3(i2))

      read(3,*) stp

      read(3,30)(id1(i),i=1,1)
 30   format(i2)



      write(9, *) 'DATA INFORMATION'
      write(9, *)
      write(9,70)kb(2),kb(1),kb(4),kb(3)
 70   format(/4x,'The beginning date is ',i2,1x,i2,4x,'The ending date
     l     is ',i3,1x,i2/)

      write(9,*)'weighted(1)/unweighte(0) flag =     ',kb(10)
      write(9,*)'convergence criteria =              ',kb(11)
      write(9,*)'number of observation(w/ missing) = ',n1
      write(9,*)

      write(9,*)'years covered      ',n3
      write(9,*)'max. observations  ',n4
      write(9,*)

      close(unit=3)

c      open(unit=3,file='level.dat',status='old')
c      read(3,40)(level(i),i=1,15)
c 40   format(15(A2))
c      close(unit=3)



      call xmatrix(kb,f107,xts,inf_time)

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine lls(x,y,b,e,u,v,M,N,maxM,maxN)

      integer maxM,maxN,M,N,i,j
      double precision s,e(100),h(50,50),b(maxN),
     1 x(maxM,maxN),y(maxM),u(maxM),v(maxM),var,mean

      do 10 i=1,N
         do 15 j=1,N
            h(i,j)=0.0
 15      continue
         b(i)=0.0
         e(i)=0.0
 10   continue

      do 20 k=1,M
         do 25 i=1,N
            do 28 j=1,N
               h(i,j)=h(i,j)+x(k,i)*x(k,j)
 28         continue
            e(i)=e(i)+x(k,i)*y(k)
 25      continue
 20   continue

      call gsweep(h,N,maxN)
      do 50 i=1,N
         do 55 j=1,N
            b(i)=b(i)+h(i,j)*e(j)
 55      continue
 50   continue


      var=0.0
      mean=0.0
      do 120 i=1,M
         v(i)=0.0
         do 110 j=1,N
            v(i)=v(i)+x(i,j)*b(j)
 110     continue
         u(i)=y(i)-v(i)
         var=var+u(i)**2
         mean=mean+u(i)
 120  continue
      var=var/(M-N)
      mean=mean/M
      s=sqrt(var)
      do 130 i=1,M
         if(abs(u(i)-mean).gt.3*s) y(i)=v(i)
 130  continue

      do 140 i=1,N
         e(i)=dsqrt(h(i,i)*var)
 140  continue

      return
      end


      subroutine setlevel(level)
      character*8 level(15)


      level(1)='Data'

      return
      end

c**** written by XZ Bai in June,1998

      subroutine NLNUSR1(NPROB,YXDATA,RESID,PARAM,NOBVAR,n1,NOVARS,
     1     NOPARS,NOB)

      integer NPROB,NOBVAR,NOVARS,NOPARS,NOB
      DOUBLE PRECISION YXDATA
      DIMENSION YXDATA(1000,100),NOBVAR(NOVARS)

      COMMON / DATA / P

*     objective functions needed in zxssq
      integer n1,n4,n3,season(1000),bmis(100),nmis(100)
      double precision RESID(1000),PARAM(100), u(1000),
     1     sgmw(12),A(100,100), B(100,100),B1(100,100),
     1     alpha(100),alpha1(100),alpha3(100),W(100),
     1     val,ss, phi(-200:200)
      common season/bn/bmis,nmis/s/sgmw/nn/n4,n5,n2,ip

      n3=nopars

      do 10 i=-200,200
         phi(i)=0.0
 10   continue

      phi(0)=1.0
      do 20 i=1,ip
         phi(i)=-PARAM(n2+i)
 20   continue

      do 25 i=1, 100
         do 24 j=1, 100
            A(i,j)=phi(ip+i-j)
 24      continue
 25   continue

      do 50 i=1,n1
         u(i)=yxdata(i,1)
         do 52 j=1,n3-ip
            u(i)=u(i)- yxdata(i,j+1)*PARAM(j)
 52      continue
 50   continue

      do 30 i=1,ip
         RESID(i)=0.0
 30   continue

      do 60 i=ip+1,n1
         RESID(i)=u(i)
         do 61 j=1,ip
            RESID(i)=RESID(i)-PARAM(j+n2)*u(i-j)
 61      continue
         j=season(i)
         RESID(i)=RESID(i)/dsqrt(sgmw(j))
 60   continue

      if(ip.eq.1) then
         val=0.0
         ss=0.0
         do 40 j=1,n2
            val=val+PARAM(j)*yxdata(1,j+1)
 40      continue
         do 45 i=1,12
            ss=ss+sgmw(season(14-i))*(PARAM(n3)**(2*(i-1)))
 45      continue
         ss=ss/(1-PARAM(n3)**24)
         if(abs(PARAM(n2+1)).gt.1.0)then
            RESID(1)=0.0
         else
            RESID(1)=(yxdata(1,1)-val)/dsqrt(ss)
         endif
      endif


      do 1000 k=1,n4

         m0=nmis(k)
         m1=nmis(k)+ip

         do 100 i=bmis(k),bmis(k)+nmis(k)-1
            u(i)=0.0
            RESID(i)=0.0
 100     continue

         do 110 i=1,ip
            alpha1(i)=u(bmis(k)+i-ip-1)
            alpha3(i)=u(bmis(k)+nmis(k)+i-1)
 110     continue

         do 120 i=1,m1+1
            ii=season(bmis(k)+i-1)
            W(i)=sgmw(ii)
 120     continue

         do 150 i=1, nmis(k)+2*ip
            do 160 j=1, nmis(k)+2*ip
               B(i,j)=0.0
               do 170 jj=1,nmis(k)+ip
                  B(i,j)=B(i,j)+A(jj,i)*A(jj,j)/W(jj)
 170           continue
 160        continue
 150     continue

         do 180 i=1,nmis(k)
            do 181 j=1, nmis(k)
               B1(i,j)=B(i+ip,j+ip)
 181        continue
 180     continue

         do 200 i=1,nmis(k)
            alpha(i)=0.0
            do 210 j=1,ip
               alpha(i)=alpha(i)+B(i+ip,j)*alpha1(j)
     1              +B(i+ip,j+m1)*alpha3(j)
 210        continue
 200     continue

         call gsweep(B1,nmis(k),100)

        val=0.0E+0
        do 220 i=1,ip
            do 230 j=1,ip
               val = val + B(i,j)*alpha1(i)*alpha1(j)
     1              + 2.0*B(i+m1,j)*alpha1(j)*alpha3(i)
     1              + B(i+m1,j+m1)*alpha3(i)*alpha3(j)

 230        continue
 220     continue

         do 240 i=1,nmis(k)
            do 250 j=1,nmis(k)
               val = val -  B1(i,j)*alpha(i)*alpha(j)
 250        continue
 240     continue

         RESID(bmis(k)+nmis(k))=val
         if(val.le.0.0)RESID(bmis(k)+nmis(k))=0.1
         RESID(bmis(k)+nmis(k))=dsqrt(abs(RESID(bmis(k)+nmis(k))))

c         do 300 i=1, ip
c            RESID(bmis(k)+nmis(k)+ i-1)=0.0
c 300     continue
 1000 continue

      do 1500 i=1, n1
         write(16, 2000) i, u(i), RESID(i)
 1500 continue
 2000 format(i10,2f15.10)

      return
      end

      subroutine output100(file,ind, b,e,ik,kb)

      integer i,file,ind,ip,n2,kb(20)
      double precision e(100),b(50)
      character*32 title
      character*64 A
      common /nn/n4,n5,n2,ip

      if (ind.eq.0) then
         title='THE INITIAL LS ESTIMATION'
      else
         title='MAXIMIUM LIKELIHOOD ESTIMATION'
      endif

      A= 'Estimate        Standard Deviation        T'

      write(file,*) title
      write(file,*)' '
      write(file,200)A
      write(file,*)' '
      write(file,210)b(1),E(1),b(1)/E(1)
      do 10 i=2,n2
         write(file,220) i-1,b(i),E(i),b(i)/E(i)
C	if (ind.ne.0.and.i.eq.(n2)) then
C		write(30,220) i-1,b(i),E(i),b(i)/E(i)
C	endif
  10   continue
    	if (ind.ne.0.and.ik.eq.1) then
		do 15 i=1,n2
			write(31,17) b(i),E(i)
 15		continue
	endif

 17     format(2(f12.4,2x))

      do 20 i=1,ip
         write(file,230) i,b(n2+i),ind*E(n2+i),ind*b(n2+i)/E(n2+i)
 20   continue

 200  format(25x,A64)
 210  format(4x,'Constant',8x,f12.4,10x,f8.4,10x,f10.4)
 220  format(4x,'Variable X',i2,4x,f12.4,10x,f8.4,10x,f10.4)
 230  format(4x,'Phi',i2,11x,f12.4,10x,f8.4,10x,f10.4)
      return
      end

      subroutine output200(file,ik,n1,m1,x,y,b,R,year,month)

      integer year(1000,3),month(1000,3),season(1000),m1,file,
     1     bmis(100),nmis(100), cnty
      double precision x(1000,50),y(1000),R(1000),u(1000),b(50),
     1     sgmw(12),tem, sst, sse, sumy
      common season/bn/bmis,nmis/s/sgmw/nn/n4,n5,n2,ip

      do 10 i=1,4
         tem=dsqrt(sgmw(i))
         write(file,15) tem
 10   continue
 15   format(8x,'s.e. is',f11.5)

      write(file, *) ' '
      write(file, *) 'RESIDUAL OUTPUT'
      write(file, *) ' '
      do 20 i=1,m1
         u(i)=y(i)
         do 30 j=1,n2
            u(i)=u(i)-x(i,j)*b(j)
 30      continue
 20   continue
      sst = 0

      sse = 0

      sumy = 0
      cnty = 0

      k2=0
      j=0
      do 1000 k=1,n4
         k1=k2+1
         k2=bmis(k)-1

         do 40 i=k1,k2
            j=j+1
            sst = sst + y(j)**2

            sse = sse + u(j)**2

            sumy = sumy + y(j)

            cnty = cnty + 1
            write(file, 100) ik,i,year(i,3),month(i,3),season(i),
     1           y(j),u(j),R(i)
 40      continue

         k1=k2+1
         k2=bmis(k)+nmis(k)-1
         do 50 i=k1,k2
            write(file, 110) ik,i,year(i,3),month(i,3),season(i),
     1           'na','na','na'
 50      continue
 1000 continue

      k1=bmis(n4)+nmis(n4)
      k2=n1
      do 60 i=k1,k2
         j=j+1
         sst = sst + y(j)**2

         sse = sse + u(j)**2

         sumy = sumy + y(j)

         cnty = cnty + 1
         write(file, 100) ik,i,year(i,3),month(i,3),season(i),
     1        y(j),u(j),R(i)
 60   continue
      write(31, *) 'R^2 = ', 1 - sse/(sst - sumy**2 / cnty)

 100  format(i2,1x,i3,1x,i2,1x,i2,1x,i2,3(1x,f11.5))
 110  format(i2,1x,i3,1x,i2,1x,i2,1x,i2,3(10x,a2))

      return
      end




c***  new version, only good for ip=0,1

      subroutine NLNUSR(NPROB,YXDATA,RESID,PARAM,NOBVAR,n1,NOVARS,
     1     NOPARS,NOB)

      integer NPROB,NOBVAR,NOVARS,NOPARS,NOB
      DOUBLE PRECISION YXDATA
      DIMENSION YXDATA(1000,100),NOBVAR(NOVARS)

      COMMON / DATA / P

*     objective functions needed in zxssq
      integer n1,n4,n3,season(1000),bmis(100),nmis(100)
      double precision RESID(1000),PARAM(100), u(1000),
     1     sgmw(12), ss, phi,phin
      common season/bn/bmis,nmis/s/sgmw/nn/n4,n5,n2,ip

      n3=nopars


      phi=0.0
      if (ip.eq.1) phi=PARAM(n3)


      do 10 i=1,n1
         u(i)=yxdata(i,1)
         do 20 j=1,n3-ip
            u(i)=u(i)- yxdata(i,j+1)*PARAM(j)
 20      continue
 10   continue

      ss=0.0
      do 45 i=1,12
         ss=ss+sgmw(season(14-i))*(PARAM(n3)**(2*(i-1)))
 45   continue
      ss=ss/(1-PARAM(n3)**24)
      if(abs(phi).gt.1.0)then
         RESID(1)=0.0
      else
         RESID(1)=u(1)/dsqrt(ss)
      endif

      k2=1

      do 1000 k=1,n4
         k1=k2+1
         k2=bmis(k)-1

         do 100 i=k1,k2
            j=season(i)
            RESID(i)=(u(i)-phi*u(i-1))/dsqrt(sgmw(j))
 100     continue

         k1=bmis(k)
         k2=bmis(k)+nmis(k)-1

         phin=phi
         ss=sgmw(season(k2+1))
         do 150 i=k2,k1,-1
            j=season(i)
            ss=ss+sgmw(j)*phin**2
            phin=phin*phi
            RESID(i)=0.0
            u(i)=0.0
 150     continue

         k1=bmis(k)-1
         k2=bmis(k)+nmis(k)
         RESID(k2)=(u(k2)-phin*u(k1))/sqrt(ss)
 1000 continue

      k1 = bmis(n4)+nmis(n4)+1
      k2 = n1
      do 1100 i=k1,k2
         j=season(i)
         RESID(i)=(u(i)-phi*u(i-1))/dsqrt(sgmw(j))
 1100 continue


c      do 1500 i=1, n1
c         write(16, 2000) i, u(i), RESID(i)
c 1500 continue
c 2000 format(i10, 2f15.10)

      return
      end













